=== modified file 'lib/lp/code/stories/branches/xx-source-package-branches-empty.txt'
--- lib/lp/code/stories/branches/xx-source-package-branches-empty.txt	2009-09-17 03:44:41 +0000
+++ lib/lp/code/stories/branches/xx-source-package-branches-empty.txt	2011-06-29 15:06:32 +0000
@@ -44,3 +44,14 @@
     ...     find_tag_by_id(browser.contents, 'branch-summary')))
     u'There are no branches for the \u201cfoo\u201d package
     in distro\nin Launchpad.'
+
+    >>> print_tag_with_id(browser.contents, 'distro-branch-warning')
+    This page is for a packaging branch for a program in
+    distro. Changes
+    should be made here to
+    distro packaging or
+    for changes specific to
+    distro's
+    needs. Changes to the program in general should be made on the
+    upstream branch
+    which is not currently known to Launchpad.

=== modified file 'lib/lp/code/templates/distributionsourcepackage-branches-grouped.pt'
--- lib/lp/code/templates/distributionsourcepackage-branches-grouped.pt	2010-08-23 03:30:54 +0000
+++ lib/lp/code/templates/distributionsourcepackage-branches-grouped.pt	2011-06-29 15:06:32 +0000
@@ -10,6 +10,24 @@
 
 <div metal:fill-slot="main">
 
+  <p id="distro-branch-warning">
+    <strong>This page is for a packaging branch for a program in
+    <tal:name replace="context/distribution/displayname"/>.</strong> Changes
+    should be made here to
+    <tal:name replace="context/distribution/displayname"/> packaging or
+    for changes specific to
+    <tal:name replace="context/distribution/displayname"/>'s
+    needs. Changes to the program in general should be made on the
+    upstream branch
+
+    <tal:upstream condition="context/upstream_product">
+        <a tal:replace="structure context/upstream_product/fmt:link" />.
+    </tal:upstream>
+    <tal:no-upstream condition="not: context/upstream_product">
+        which is not currently known to Launchpad.
+    </tal:no-upstream>
+  </p>
+
   <tal:no-branches condition="not: view/branch_count">
     <div id="branch-summary">
     There are no branches for the <tal:name replace="context/title"/>

